//-------------------------------------------------------------------------------
// Title       : data_select_stage
// Author      : Adarsh       Maintenance : Tullio Grassi
// Description : just an array of 8 multiplexers
//-------------------------------------------------------------------------------
`timescale 1ns / 1ps

module data_select_stage (
  SysClkx2,   sel,   
  Ch1_RX_D,   Ch1_RX_ER,    Ch1_RX_DV,      
  Ch2_RX_D,   Ch2_RX_ER,    Ch2_RX_DV,    
  Ch3_RX_D,   Ch3_RX_ER,    Ch3_RX_DV,    
  Ch4_RX_D,   Ch4_RX_ER,    Ch4_RX_DV,    
  Ch5_RX_D,   Ch5_RX_ER,    Ch5_RX_DV,    
  Ch6_RX_D,   Ch6_RX_ER,    Ch6_RX_DV,        
  Ch7_RX_D,   Ch7_RX_ER,    Ch7_RX_DV,    
  Ch8_RX_D,   Ch8_RX_ER,    Ch8_RX_DV,    
  Pattern1, Pattern2, Pattern3, Pattern4,
  Pattern5, Pattern6, Pattern7, Pattern8,  
  Ch1_Input_Data_o,     Ch2_Input_Data_o,    
  Ch3_Input_Data_o,     Ch4_Input_Data_o,     
  Ch5_Input_Data_o,     Ch6_Input_Data_o,          
  Ch7_Input_Data_o,     Ch8_Input_Data_o       );
  
  input SysClkx2,  sel;
  input [15:0]  Ch1_RX_D,  Ch2_RX_D,  Ch3_RX_D,  Ch4_RX_D,  
                Ch5_RX_D,  Ch6_RX_D,  Ch7_RX_D,  Ch8_RX_D;   
  input    Ch1_RX_ER, Ch1_RX_DV,   Ch2_RX_ER, Ch2_RX_DV, 
           Ch3_RX_ER, Ch3_RX_DV,   Ch4_RX_ER, Ch4_RX_DV, 
           Ch5_RX_ER, Ch5_RX_DV,   Ch6_RX_ER, Ch6_RX_DV,
           Ch7_RX_ER, Ch7_RX_DV,   Ch8_RX_ER, Ch8_RX_DV;         
  input  [17:0] Pattern1, Pattern2, Pattern3, Pattern4,
                Pattern5, Pattern6, Pattern7, Pattern8;
  
  output [17:0]   Ch1_Input_Data_o,    Ch2_Input_Data_o,
                  Ch3_Input_Data_o,    Ch4_Input_Data_o, 
                  Ch5_Input_Data_o,    Ch6_Input_Data_o, 
                  Ch7_Input_Data_o,    Ch8_Input_Data_o;
      
 mux18        mux_ch1
  ( .ck(SysClkx2),            .sel(sel), 
    .Din_One(Pattern1),
    .Din_Zero({Ch1_RX_ER, Ch1_RX_DV, Ch1_RX_D}), 
    .Mux_Out(Ch1_Input_Data_o)                      );
 
 mux18        mux_ch2
  ( .ck(SysClkx2),            .sel(sel), 
    .Din_One(Pattern2),
    .Din_Zero({Ch2_RX_ER, Ch2_RX_DV, Ch2_RX_D}), 
    .Mux_Out(Ch2_Input_Data_o)                      );
 
 mux18        mux_ch3
  ( .ck(SysClkx2),            .sel(sel), 
    .Din_One(Pattern3),
    .Din_Zero({Ch3_RX_ER, Ch3_RX_DV, Ch3_RX_D}), 
    .Mux_Out(Ch3_Input_Data_o)                      );
 
 mux18        mux_ch4
  ( .ck(SysClkx2),            .sel(sel), 
    .Din_One(Pattern4),
    .Din_Zero({Ch4_RX_ER, Ch4_RX_DV, Ch4_RX_D}), 
    .Mux_Out(Ch4_Input_Data_o)                      );
 
 mux18        mux_ch5
  ( .ck(SysClkx2),            .sel(sel), 
    .Din_One(Pattern5),
    .Din_Zero({Ch5_RX_ER, Ch5_RX_DV, Ch5_RX_D}), 
    .Mux_Out(Ch5_Input_Data_o)                      );
 
 mux18        mux_ch6
  ( .ck(SysClkx2),            .sel(sel), 
    .Din_One(Pattern6),
    .Din_Zero({Ch6_RX_ER, Ch6_RX_DV, Ch6_RX_D}), 
    .Mux_Out(Ch6_Input_Data_o)                      );
 
 mux18        mux_ch7
  ( .ck(SysClkx2),            .sel(sel), 
    .Din_One(Pattern7),
    .Din_Zero({Ch7_RX_ER, Ch7_RX_DV, Ch7_RX_D}), 
    .Mux_Out(Ch7_Input_Data_o)                      );
 
 mux18        mux_ch8
  ( .ck(SysClkx2),            .sel(sel), 
    .Din_One(Pattern8),
    .Din_Zero({Ch8_RX_ER, Ch8_RX_DV, Ch8_RX_D}), 
    .Mux_Out(Ch8_Input_Data_o)                      );
 
endmodule

