//--------------------------------------------------------------------------------------------------
// Title       : spdblockram_op     
// Syntax for XST synthasizer
//-------------------------------------------------------------------------------------------------
`include "define.v"

module spdblockram_op (clk, we, a, di, do); 
 
 input  clk, we; 
 input  [`COMPR_LUT_ADDR_WIDTH - 1:0] a; 
 input  [`COMPR_LUT_DATA_WIDTH - 1:0] di;  
 output [`COMPR_LUT_DATA_WIDTH - 1:0] do; 
 
 reg    [`COMPR_LUT_DATA_WIDTH - 1:0] ram [`OUTPUT_LUT_DEPTH - 1:0]; 
 reg    [`COMPR_LUT_ADDR_WIDTH - 1:0]  read_a; 
 
 always @(posedge clk) begin 
 	if (we)  		ram[a] <= di; 
 	read_a <= a; 
 end 
 
 assign do = ram[read_a]; 
 
 endmodule
