//
// apply an ET threshold, used for the luminosity.  the ET is the sum over
// 2 time slots...
//
module threshold(
	input clock,
	input Mask,
   input [9:0] ET, ETlow, EThigh,
   output reg [1:0] dout,
	input fena, foff
   );

reg[1:0] out;
wire high = (ET > EThigh);
wire low = (ET > ETlow);
always @ (Mask or low or high)
  case (Mask)
    0: begin
	   if (fena) begin
		  out = foff ? 'b11 : 'b01;
      end
		else begin
	     case ({high,low})
		  0: out = 'b01;
		  1: out = 'b10;
		  2: out = 'b11;
		  3: out = 'b11;
		  endcase
		end
	 end
	 1: out = 'b00;
  endcase
/*
if (Mask) out = 'b00;  
else begin
    if (ET > EThigh) out = 'b11;
    else if (ET > ETlow) out = 'b10;
    else out = 'b01;
  end
*/
reg[1:0] out2;
always @ (posedge clock) begin
  out2 <= #1 out;
  dout <= #1 out2;
  end

endmodule